MB_stat <- function (r_vector, r, n){
  return (factorial(r) * n^(-r) / (prod(factorial(r_vector))))
}

get_proba_exac <- function (k, r, n, r_vect){
  proba <- 0
  
  if (length(r_vect) < n){
    for (r_i in 0:(r - sum(r_vect)))
      proba <- proba + get_proba_exac(k, r, n, c(r_vect, r_i))
  }
  else
    if (sum(r_vect) == r)
      if (k %in% r_vect)
        proba <- proba + MB_stat(r_vect, r, n)

  return (proba)
}

get_proba_exac(6, 10, 6, c())

get_proba_at_least_k <- function (k, r, n, r_vect){
  proba <- 0
  
  if (length(r_vect) < n){
    for (r_i in 0:(r - sum(r_vect)))
      proba <- proba + get_proba_at_least_k(k, r, n, c(r_vect, r_i))
  }
  else
      if (sum(r_vect) == r)
        if (sum((k:r) %in% r_vect))
          proba <- proba + MB_stat(r_vect, r, n)

  return (proba)
}

get_proba_at_least_k(8, 10, 6, c())
1-get_proba_at_least_k(3, 5, 6, c())


##### Real game

# at least k identical dices (pako included)
get_proba_at_least_k_with_pako <- function (k, r, n, r_vect){
  proba <- 0
  
  if (length(r_vect) < n){
    for (r_i in 0:(r - sum(r_vect)))
      proba <- proba + get_proba_at_least_k_with_pako(k, r, n, c(r_vect, r_i))
  }
  else
    if (sum(r_vect) == r)
      if ( sum ( (k:r) %in% (r_vect[2:length(r_vect)] + r_vect[1]) ) )
        proba <- proba + MB_stat(r_vect, r, n)
    
    return (proba)
}

get_proba_at_least_k_with_pako(8, 17, 6, c())

# at least k identical pako dices (pako only (binomial event))
get_proba_at_least_k_only_pako <- function (k, r, n){
  proba <- 0
  
  for (i in 0:k-1)
    proba <- proba + dbinom(i, r, 1/n)
  
  return (1 - proba)
}

get_proba_at_least_k_only_pako(3, 25, 6)
get_proba_at_least_k_with_pako(4, 10, 6, c())
get_proba_at_least_k_only_pako(1, 1, 6)

perudo <- matrix(0,25,25)

for (r in 1:25){
  for (k in 1:r){
    perudo[k, r] <- get_proba_at_least_k_only_pako(k, r, 6)
  }
}

perudo

write.csv(data.frame(perudo), file = "pako_only.csv")

perudo <- matrix(0,25,25)

for (r in 1:25){
  for (k in 1:r){
    perudo[k, r] <- get_proba_at_least_k_with_pako(k, r, 6, c())
  }
}

perudo

write.csv(data.frame(perudo), file = "any number (not pako).csv")



